//========================================================================================
//
//	File:				PRCharIt.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PRCHARIT_H
#define PRCHARIT_H

#ifndef SOM_Module_ODFStringSubsystemTypes_defined
#include "FWTxtTyp.xh"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_OTextRunReader;
class FW_OTextRunWriter;

//========================================================================================
//	STRUCT FW_SPrivTextReader
//========================================================================================

struct FW_SPrivTextReader
{
	FW_OTextRunReader* 	fReader;
	const char*			fStart;			// Start of current run
	const char*			fLimit;			// One past last byte of current run
	const char*			fNext;			// Current position in run
	FW_ByteCount		fByteLength;	// Total bytes in data structure.
	FW_ByteCount		fBufferSum;		// Total bytes in previous buffers.
	FW_Locale			fLocale;		// Locality of current run
	long				fRefCount;		// Reference count
};

//========================================================================================
//	STRUCT FW_SPrivTextWriter
//========================================================================================

struct FW_SPrivTextWriter
{
	FW_OTextRunWriter* 	fWriter;
	char*				fStart;			// Start of current run
	char*				fLimit;			// One past last byte of current run
	char*				fNext;			// Current position in run
	FW_ByteCount		fBufferSum;		// Total bytes in previous buffers.
	FW_Locale			fLocale;		// Locality of current run
	long				fRefCount;		// Reference count
};

#endif
