//========================================================================================
//
//	File:				FWAPStr.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================
// We separate the archiving functions into their own translation units in order to
// enable dead-stripping.

#include "FWFound.hpp"

#ifndef FWPSTR_H
#include "FWPStr.h"
#endif

//========================================================================================
// File scope definitions
//========================================================================================

#ifdef FW_BUILD_MAC
#pragma segment Strings
#endif

//========================================================================================
//	CLASS FW_CString
//========================================================================================

const FW_ClassTypeConstant FW_LString = FW_TYPE_CONSTANT('s','t','r','i');
FW_REGISTER_ARCHIVABLE_CLASS(FW_LString, FW_CString, FW_CString::Read, 0, 0, FW_CString::Write)

//----------------------------------------------------------------------------------------
// FW_CString::Read
//----------------------------------------------------------------------------------------

void* FW_CString::Read(FW_CReadableStream& stream, FW_ClassTypeConstant type)
{
FW_UNUSED(type);
	FW_CString* string = FW_NEW(FW_CString, ());
	string->PrivRead(stream);
	return string;
}

//----------------------------------------------------------------------------------------
// FW_CString::Write
//----------------------------------------------------------------------------------------

void FW_CString::Write(FW_CWritableStream& stream, FW_ClassTypeConstant type, const void *object)
{
FW_UNUSED(type);
	const FW_CString* string = (const FW_CString*) object;
	string->PrivWrite(stream);
}

